#
#########################################################################################################
#
#       .  Unmount,  Detach
#  $hosts -  
#  $storage -   /.
#
#########################################################################################################


#  ,   
if ( (Get-PSSnapin -Name VMware.VimAutomation.Core -ErrorAction SilentlyContinue) -eq $null ) 
{
	add-pssnapin VMware.*
}
else 
{
	Write-Host "Snap in already added."
}

#################################################
#     
Set-powercliconfiguration -InvalidCertificateAction Ignore -Confirm:$false | out-null
#################################################


#vCenter Server
$vCenter = "bs-vc"


#I     vCentr,  
if ($global:DefaultVIServers.Count -lt 1) 
{ 
	Connect-VIServer $vCenter 
}

#   ESX-
#$hosts = (Get-Content D:\PowerCLI\1unmountdatastoresservers.txt)
#   
# $hosts = Get-VMhost

#   
$hosts = "bs-esx07", "bs-esx08"

#  Datastores,   
#$storage = (Get-Content D:\PowerCLI\storage.txt)
$storage = "SAS_ThinClient_A_1", "SAS_ThinClient_A_2", "SAS_ThinClient_B_1", "SAS_ThinClient_B_2"

#    
foreach($esx in $hosts)
{
	Write-host "Servers: " $esx
	#       esxcli
	$esxcli = Get-ESXCLI -VMHost $esx
	#Hosts Datastores
	$hostds=Get-Datastore -VMhost $esx
	#     
	foreach ($st in $storage)
	{
		
		foreach($hds in $hostds)
		{
		 #Write-Host " : " $hds

		 if ($st -eq $hds) 
		 {
			Write-Host
			Write-Host "Server: " $esx "have mapped datastores " $hds
			Write-Host
			
			#    SIOC,  ,  .
			$SIOC = Get-Datastore -Name $hds
			if ($SIOC.StorageIOControlEnabled -eq $True) 
			{ 
				Set-Datastore $hds -StorageIOControlEnabled $false
				# ,    SIOC
				Start-Sleep -s 10
			}
			$lun = $esxcli.storage.vmfs.extent.list() | Where-Object {$_.VolumeName -eq $hds}
			$device_id=$lun.DeviceName
			#Unmount Datastore
			Write-Host "Unmount datastore " $hds " from " $esx
			$esxcli.storage.filesystem.unmount($true,$hds)
			#Detach Datastore
			Write-Host "Detach datastore " $hds " from " $esx
			$esxcli.storage.core.device.set($device_id,"IsOffline",$null,"off")
			# Force device to be administratively online
			#$esxcli.storage.core.device.set($device_id,"IsOffline",$null,"on")
						
		 }
		}
	}#       
} #     


